diff --git a/python/mozbuild/mozbuild/configure/util.py b/python/mozbuild/mozbuild/configure/util.py
index c7a305282b..c7bc64e575 100644
--- a/python/mozbuild/mozbuild/configure/util.py
+++ b/python/mozbuild/mozbuild/configure/util.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import codecs
 import itertools
@@ -12,7 +11,27 @@ import os
 import sys
 from collections import deque
 from contextlib import contextmanager
-from distutils.version import LooseVersion
+import re
+class LooseVersion:
+    """Simple version comparison (replacement for distutils.version.LooseVersion)."""
+    def __init__(self, vstring):
+        self.vstring = vstring
+        self.version = [int(x) if x.isdigit() else x for x in re.split(r'[.\-]', vstring)]
+    def __str__(self): return self.vstring
+    def __repr__(self): return "LooseVersion('%s')" % self.vstring
+    def _cmp(self, other):
+        if not isinstance(other, LooseVersion):
+            other = LooseVersion(str(other))
+        try:
+            if self.version == other.version: return 0
+            if self.version < other.version: return -1
+            return 1
+        except TypeError: return -1
+    def __lt__(self, o): return self._cmp(o) < 0
+    def __le__(self, o): return self._cmp(o) <= 0
+    def __eq__(self, o): return self._cmp(o) == 0
+    def __ge__(self, o): return self._cmp(o) >= 0
+    def __gt__(self, o): return self._cmp(o) > 0
 
 def getpreferredencoding():
     # locale._parse_localename makes locale.getpreferredencoding
@@ -52,7 +71,7 @@ class Version(LooseVersion):
 
     def __cmp__(self, other):
         # LooseVersion checks isinstance(StringType), so work around it.
-        if isinstance(other, unicode):
+        if isinstance(other, str):
             other = other.encode('ascii')
         return LooseVersion.__cmp__(self, other)
 
@@ -73,20 +92,13 @@ class ConfigureOutputHandler(logging.Handler):
     manager.
     '''
     def __init__(self, stdout=sys.stdout, stderr=sys.stderr, maxlen=20):
-        super(ConfigureOutputHandler, self).__init__()
+        super().__init__()
 
         # Python has this feature where it sets the encoding of pipes to
         # ascii, which blatantly fails when trying to print out non-ascii.
         def fix_encoding(fh):
-            try:
-                isatty = fh.isatty()
-            except AttributeError:
-                isatty = True
-
-            if not isatty:
-                encoding = getpreferredencoding()
-                if encoding:
-                    return codecs.getwriter(encoding)(fh)
+            # In Python 3, text streams handle encoding natively.
+            # Just return the stream as-is.
             return fh
 
         self._stdout = fix_encoding(stdout)
@@ -190,7 +202,7 @@ class ConfigureOutputHandler(logging.Handler):
         self._keep_if_debug = self.KEEP
 
 
-class LineIO(object):
+class LineIO:
     '''File-like class that sends each line of the written data to a callback
     (without carriage returns).
     '''
@@ -200,8 +212,8 @@ class LineIO(object):
         self._encoding = getpreferredencoding()
 
     def write(self, buf):
-        if self._encoding and isinstance(buf, str):
-            buf = buf.decode(self._encoding)
+        if isinstance(buf, bytes):
+            buf = buf.decode(self._encoding or 'utf-8', errors='replace')
         lines = buf.splitlines()
         if not lines:
             return
diff --git a/python/mozbuild/mozbuild/controller/building.py b/python/mozbuild/mozbuild/controller/building.py
index 663f789b8e..4d59d216f2 100644
--- a/python/mozbuild/mozbuild/controller/building.py
+++ b/python/mozbuild/mozbuild/controller/building.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
+from __future__ import print_function
 import getpass
 import json
 import logging
@@ -62,7 +62,7 @@ BuildOutputResult = namedtuple('BuildOutputResult',
     ('warning', 'state_changed', 'for_display'))
 
 
-class TierStatus(object):
+class TierStatus:
     """Represents the state and progress of tier traversal.
 
     The build system is organized into linear phases called tiers. Each tier
@@ -470,7 +470,7 @@ class BuildMonitor(MozbuildObject):
         return ccache_stats
 
 
-class CCacheStats(object):
+class CCacheStats:
     """Holds statistics from ccache.
 
     Instances can be subtracted from each other to obtain differences.
@@ -625,7 +625,7 @@ class CCacheStats(object):
         lines = []
 
         if self.cache_dir:
-            lines.append('%s%s' % (self.DIRECTORY_DESCRIPTION.ljust(LEFT_ALIGN),
+            lines.append('{}{}'.format(self.DIRECTORY_DESCRIPTION.ljust(LEFT_ALIGN),
                                    self.cache_dir))
 
         for stat_key, stat_description in self.STATS_KEYS:
@@ -639,7 +639,7 @@ class CCacheStats(object):
             else:
                 value = '%8u' % value
 
-            lines.append('%s%s' % (stat_description.ljust(LEFT_ALIGN), value))
+            lines.append('{}{}'.format(stat_description.ljust(LEFT_ALIGN), value))
 
         return '\n'.join(lines)
 
@@ -666,8 +666,8 @@ class BuildDriver(MozbuildObject):
         """Install test files."""
 
         if self.is_clobber_needed():
-            print(INSTALL_TESTS_CLOBBER.format(
-                  clobber_file=os.path.join(self.topobjdir, 'CLOBBER')))
+            print((INSTALL_TESTS_CLOBBER.format(
+                  clobber_file=os.path.join(self.topobjdir, 'CLOBBER'))))
             sys.exit(1)
 
         if not test_objs:
diff --git a/python/mozbuild/mozbuild/controller/clobber.py b/python/mozbuild/mozbuild/controller/clobber.py
index ba83e24285..a3f0ea5700 100644
--- a/python/mozbuild/mozbuild/controller/clobber.py
+++ b/python/mozbuild/mozbuild/controller/clobber.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function
 
 r'''This module contains code for managing clobbering of the tree.'''
 
@@ -39,7 +38,7 @@ Well, are ya? -- you can ignore this clobber requirement by running:
  $ touch {clobber_file}
 '''.splitlines()])
 
-class Clobberer(object):
+class Clobberer:
     def __init__(self, topsrcdir, topobjdir):
         """Create a new object to manage clobbering the tree.
 
@@ -86,7 +85,7 @@ class Clobberer(object):
         This returns a list of lines describing why the clobber was required.
         Each line is stripped of leading and trailing whitespace.
         """
-        with open(self.src_clobber, 'rt') as fh:
+        with open(self.src_clobber) as fh:
             lines = [l.strip() for l in fh.readlines()]
             return [l for l in lines if l and not l.startswith('#')]
 
@@ -114,14 +113,13 @@ class Clobberer(object):
         }
 
         if full:
-            # mozfile doesn't like unicode arguments (bug 818783).
-            paths = [self.topobjdir.encode('utf-8')]
+            paths = [self.topobjdir]
         else:
             try:
                 paths = []
                 for p in os.listdir(self.topobjdir):
                     if p not in no_clobber:
-                        paths.append(os.path.join(self.topobjdir, p).encode('utf-8'))
+                        paths.append(os.path.join(self.topobjdir, p))
             except OSError as e:
                 if e.errno != errno.ENOENT:
                     raise
@@ -200,7 +198,7 @@ class Clobberer(object):
             self.ensure_objdir_state()
             print('Successfully completed auto clobber.', file=fh)
             return True, True, None
-        except (IOError) as error:
+        except (OSError) as error:
             return True, False, self._message(
                 'Error when automatically clobbering: ' + str(error))
 
diff --git a/python/mozbuild/mozbuild/doctor.py b/python/mozbuild/mozbuild/doctor.py
index 2175042bfa..37c9786500 100644
--- a/python/mozbuild/mozbuild/doctor.py
+++ b/python/mozbuild/mozbuild/doctor.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, # You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
+from __future__ import print_function
 import os
 import subprocess
 import sys
@@ -11,7 +11,27 @@ import sys
 import psutil
 
 from distutils.util import strtobool
-from distutils.version import LooseVersion
+import re
+class LooseVersion:
+    """Simple version comparison (replacement for distutils.version.LooseVersion)."""
+    def __init__(self, vstring):
+        self.vstring = vstring
+        self.version = [int(x) if x.isdigit() else x for x in re.split(r'[.\-]', vstring)]
+    def __str__(self): return self.vstring
+    def __repr__(self): return "LooseVersion('%s')" % self.vstring
+    def _cmp(self, other):
+        if not isinstance(other, LooseVersion):
+            other = LooseVersion(str(other))
+        try:
+            if self.version == other.version: return 0
+            if self.version < other.version: return -1
+            return 1
+        except TypeError: return -1
+    def __lt__(self, o): return self._cmp(o) < 0
+    def __le__(self, o): return self._cmp(o) <= 0
+    def __eq__(self, o): return self._cmp(o) == 0
+    def __ge__(self, o): return self._cmp(o) >= 0
+    def __gt__(self, o): return self._cmp(o) > 0
 import mozpack.path as mozpath
 
 # Minimum recommended logical processors in system.
@@ -83,7 +103,7 @@ class Doctor(object):
         valid = False
         while not valid and limit > 0:
             try:
-                choice = strtobool(raw_input(prompt + '[Y/N]\n'))
+                choice = strtobool(input(prompt + '[Y/N]\n'))
                 valid = True
             except ValueError:
                 print("ERROR! Please enter a valid option!")
@@ -103,11 +123,11 @@ class Doctor(object):
             if status == 'SKIPPED':
                 continue
             self.results.append(result)
-            print('%s...\t%s\n' % (
+            print(('%s...\t%s\n' % (
                    result.get('desc', ''),
                    status
                 )
-            ).expandtabs(40)
+            ).expandtabs(40))
 
     @property
     def platform(self):
@@ -212,7 +232,7 @@ class Doctor(object):
                         fsutil_output = subprocess.check_output(command)
                         status = 'GOOD, FIXED'
                         desc = 'lastaccess disabled systemwide'
-                    except subprocess.CalledProcessError, e:
+                    except subprocess.CalledProcessError as e:
                         desc = 'lastaccess enabled systemwide'
                         if e.output.find('denied') != -1:
                             status = 'BAD, FIX DENIED'
diff --git a/python/mozbuild/mozbuild/dotproperties.py b/python/mozbuild/mozbuild/dotproperties.py
index 972ff23299..b2d8d19ed8 100644
--- a/python/mozbuild/mozbuild/dotproperties.py
+++ b/python/mozbuild/mozbuild/dotproperties.py
@@ -5,16 +5,12 @@
 # This file contains utility functions for reading .properties files, like
 # region.properties.
 
-from __future__ import absolute_import, unicode_literals
 
 import codecs
 import re
 import sys
 
-if sys.version_info[0] == 3:
-    str_type = str
-else:
-    str_type = basestring
+str_type = str
 
 class DotProperties:
     r'''A thin representation of a key=value .properties file.'''
@@ -38,7 +34,7 @@ class DotProperties:
             line = l.strip()
             if not line or line.startswith('#'):
                 continue
-            (k, v) = re.split('\s*=\s*', line, 1)
+            (k, v) = re.split(r'\s*=\s*', line, 1)
             self._properties[k] = v
 
     def get(self, key, default=None):
@@ -52,7 +48,7 @@ class DotProperties:
         if not prefix.endswith('.'):
             prefix = prefix + '.'
         indexes = []
-        for k, v in self._properties.iteritems():
+        for k, v in self._properties.items():
             if not k.startswith(prefix):
                 continue
             key = k[len(prefix):]
@@ -73,8 +69,8 @@ class DotProperties:
         if not prefix.endswith('.'):
             prefix = prefix + '.'
 
-        D = dict((k[len(prefix):], v) for k, v in self._properties.iteritems()
-                 if k.startswith(prefix) and '.' not in k[len(prefix):])
+        D = {k[len(prefix):]: v for k, v in self._properties.items()
+                 if k.startswith(prefix) and '.' not in k[len(prefix):]}
 
         for required_key in required_keys:
             if not required_key in D:
diff --git a/python/mozbuild/mozbuild/frontend/context.py b/python/mozbuild/mozbuild/frontend/context.py
index 46f6d12cb5..711101d601 100644
--- a/python/mozbuild/mozbuild/frontend/context.py
+++ b/python/mozbuild/mozbuild/frontend/context.py
@@ -14,7 +14,6 @@ If you are looking for the absolute authority on what moz.build files can
 contain, you've come to the right place.
 """
 
-from __future__ import absolute_import, unicode_literals
 
 import os
 
@@ -50,7 +49,7 @@ from types import FunctionType
 import itertools
 
 
-class ContextDerivedValue(object):
+class ContextDerivedValue:
     """Classes deriving from this one receive a special treatment in a
     Context. See Context documentation.
     """
@@ -234,10 +233,10 @@ class Context(KeyedDefaultDict):
         This function is transactional: if setitem fails for one of the values,
         the context is not updated at all."""
         if isinstance(iterable, dict):
-            iterable = iterable.items()
+            iterable = list(iterable.items())
 
         update = {}
-        for key, value in itertools.chain(iterable, kwargs.items()):
+        for key, value in itertools.chain(iterable, list(kwargs.items())):
             stored_type = self._validate(key, value)
             # Don't create an instance of stored_type if coercion is needed,
             # until all values are validated.
@@ -253,7 +252,7 @@ class Context(KeyedDefaultDict):
 class TemplateContext(Context):
     def __init__(self, template=None, allowed_variables={}, config=None):
         self.template = template
-        super(TemplateContext, self).__init__(allowed_variables, config)
+        super().__init__(allowed_variables, config)
 
     def _validate(self, key, value):
         return Context._validate(self, key, value, True)
@@ -297,7 +296,7 @@ class InitializedDefines(ContextDerivedValue, OrderedDict):
             self.update(value)
 
 
-class FinalTargetValue(ContextDerivedValue, unicode):
+class FinalTargetValue(ContextDerivedValue, str):
     def __new__(cls, context, value=""):
         if not value:
             value = 'dist/'
@@ -307,14 +306,14 @@ class FinalTargetValue(ContextDerivedValue, unicode):
                 value += 'bin'
             if context['DIST_SUBDIR']:
                 value += '/' + context['DIST_SUBDIR']
-        return unicode.__new__(cls, value)
+        return str.__new__(cls, value)
 
 
 def Enum(*values):
     assert len(values)
     default = values[0]
 
-    class EnumClass(object):
+    class EnumClass:
         def __new__(cls, value=None):
             if value is None:
                 return default
@@ -353,9 +352,9 @@ class PathMeta(type):
                 cls = AbsolutePath
             else:
                 cls = SourcePath
-        return super(PathMeta, cls).__call__(context, value)
+        return super().__call__(context, value)
 
-class Path(ContextDerivedValue, unicode):
+class Path(ContextDerivedValue, str, metaclass=PathMeta):
     """Stores and resolves a source path relative to a given context
 
     This class is used as a backing type for some of the sandbox variables.
@@ -366,10 +365,9 @@ class Path(ContextDerivedValue, unicode):
       - '!objdir/relative/paths'
       - '%/filesystem/absolute/paths'
     """
-    __metaclass__ = PathMeta
 
     def __new__(cls, context, value=None):
-        return super(Path, cls).__new__(cls, value)
+        return super().__new__(cls, value)
 
     def __init__(self, context, value=None):
         # Only subclasses should be instantiated.
@@ -384,9 +382,11 @@ class Path(ContextDerivedValue, unicode):
         return Path(self.context, mozpath.join(self, *p))
 
     def __cmp__(self, other):
+        def _cmp(a, b):
+            return (a > b) - (a < b)
         if isinstance(other, Path) and self.srcdir != other.srcdir:
-            return cmp(self.full_path, other.full_path)
-        return cmp(unicode(self), other)
+            return _cmp(self.full_path, other.full_path)
+        return _cmp(str(self), other)
 
     # __cmp__ is not enough because unicode has __eq__, __ne__, etc. defined
     # and __cmp__ is only used for those when they don't exist.
@@ -409,7 +409,7 @@ class Path(ContextDerivedValue, unicode):
         return self.__cmp__(other) >= 0
 
     def __repr__(self):
-        return '<%s (%s)%s>' % (self.__class__.__name__, self.srcdir, self)
+        return '<{} ({}){}>'.format(self.__class__.__name__, self.srcdir, self)
 
     def __hash__(self):
         return hash(self.full_path)
@@ -426,7 +426,7 @@ class SourcePath(Path):
             raise ValueError('Object directory paths are not allowed')
         if value.startswith('%'):
             raise ValueError('Filesystem absolute paths are not allowed')
-        super(SourcePath, self).__init__(context, value)
+        super().__init__(context, value)
 
         if value.startswith('/'):
             path = None
@@ -464,7 +464,7 @@ class RenamedSourcePath(SourcePath):
     def __init__(self, context, value):
         assert isinstance(value, tuple)
         source, self._target_basename = value
-        super(RenamedSourcePath, self).__init__(context, source)
+        super().__init__(context, source)
 
     @property
     def target_basename(self):
@@ -476,7 +476,7 @@ class ObjDirPath(Path):
     def __init__(self, context, value=None):
         if not value.startswith('!'):
             raise ValueError('Object directory paths must start with ! prefix')
-        super(ObjDirPath, self).__init__(context, value)
+        super().__init__(context, value)
 
         if value.startswith('!/'):
             path = mozpath.join(context.config.topobjdir,value[2:])
@@ -492,7 +492,7 @@ class AbsolutePath(Path):
             raise ValueError('Absolute paths must start with % prefix')
         if not os.path.isabs(value[1:]):
             raise ValueError('Path \'%s\' is not absolute' % value[1:])
-        super(AbsolutePath, self).__init__(context, value)
+        super().__init__(context, value)
 
         self.full_path = mozpath.normpath(value[1:])
 
@@ -505,7 +505,7 @@ def ContextDerivedTypedList(klass, base_class=List):
     class _TypedList(ContextDerivedValue, TypedList(klass, base_class)):
         def __init__(self, context, iterable=[]):
             self.context = context
-            super(_TypedList, self).__init__(iterable)
+            super().__init__(iterable)
 
         def normalize(self, e):
             if not isinstance(e, klass):
@@ -521,7 +521,7 @@ def ContextDerivedTypedListWithItems(type, base_class=List):
     class _TypedListWithItems(ContextDerivedTypedList(type, base_class)):
         def __getitem__(self, name):
             name = self.normalize(name)
-            return super(_TypedListWithItems, self).__getitem__(name)
+            return super().__getitem__(name)
 
     return _TypedListWithItems
 
@@ -594,7 +594,7 @@ def OrderedListWithAction(action):
         def __init__(self, context, *args):
             def _action(item):
                 return item, action(context, item)
-            super(_OrderedListWithAction, self).__init__(action=_action, *args)
+            super().__init__(action=_action, *args)
 
     return _OrderedListWithAction
 
@@ -610,12 +610,12 @@ def TypedListWithAction(typ, action):
         def __init__(self, context, *args):
             def _action(item):
                 return item, action(context, item)
-            super(_TypedListWithAction, self).__init__(action=_action, *args)
+            super().__init__(action=_action, *args)
     return _TypedListWithAction
 
 WebPlatformTestManifest = TypedNamedTuple("WebPlatformTestManifest",
-                                          [("manifest_path", unicode),
-                                           ("test_root", unicode)])
+                                          [("manifest_path", str),
+                                           ("test_root", str)])
 ManifestparserManifestList = OrderedListWithAction(read_manifestparser_manifest)
 ReftestManifestList = OrderedListWithAction(read_reftest_manifest)
 WptManifestList = TypedListWithAction(WebPlatformTestManifest, read_wpt_manifest)
@@ -623,12 +623,12 @@ WptManifestList = TypedListWithAction(WebPlatformTestManifest, read_wpt_manifest
 OrderedSourceList = ContextDerivedTypedList(SourcePath, StrictOrderingOnAppendList)
 OrderedTestFlavorList = TypedList(Enum(*all_test_flavors()),
                                   StrictOrderingOnAppendList)
-OrderedStringList = TypedList(unicode, StrictOrderingOnAppendList)
+OrderedStringList = TypedList(str, StrictOrderingOnAppendList)
 DependentTestsEntry = ContextDerivedTypedRecord(('files', OrderedSourceList),
                                                 ('tags', OrderedStringList),
                                                 ('flavors', OrderedTestFlavorList))
 BugzillaComponent = TypedNamedTuple('BugzillaComponent',
-                        [('product', unicode), ('component', unicode)])
+                        [('product', str), ('component', str)])
 
 
 class Files(SubContext):
@@ -750,7 +750,7 @@ class Files(SubContext):
     }
 
     def __init__(self, parent, pattern=None):
-        super(Files, self).__init__(parent)
+        super().__init__(parent)
         self.pattern = pattern
         self.finalized = set()
         self.test_files = set()
@@ -766,8 +766,8 @@ class Files(SubContext):
 
         for k, v in other.items():
             if k == 'IMPACTED_TESTS':
-                self.test_files |= set(mozpath.relpath(e.full_path, e.context.config.topsrcdir)
-                                       for e in v.files)
+                self.test_files |= {mozpath.relpath(e.full_path, e.context.config.topsrcdir)
+                                       for e in v.files}
                 self.test_tags |= set(v.tags)
                 self.test_flavors |= set(v.flavors)
                 continue
@@ -909,7 +909,7 @@ VARIABLES = {
         """),
 
     'GENERATED_FILES': (StrictOrderingOnAppendListWithFlagsFactory({
-                'script': unicode,
+                'script': str,
                 'inputs': list }), list,
         """Generic generated files.
 
@@ -1054,7 +1054,7 @@ VARIABLES = {
         """Like ``OBJDIR_FILES``, with preprocessing. Use sparingly.
         """),
 
-    'FINAL_LIBRARY': (unicode, unicode,
+    'FINAL_LIBRARY': (str, str,
         """Library in which the objects of the current directory will be linked.
 
         This variable contains the name of a library, defined elsewhere with
@@ -1105,7 +1105,7 @@ VARIABLES = {
         """A list of python unit tests.
         """),
 
-    'HOST_LIBRARY_NAME': (unicode, unicode,
+    'HOST_LIBRARY_NAME': (str, str,
         """Name of target library generated when cross compiling.
         """),
 
@@ -1123,7 +1123,7 @@ VARIABLES = {
         libraries that link into this library via FINAL_LIBRARY.
         """),
 
-    'LIBRARY_NAME': (unicode, unicode,
+    'LIBRARY_NAME': (str, str,
         """The code name of the library generated for a directory.
 
         By default STATIC_LIBRARY_NAME and SHARED_LIBRARY_NAME take this name.
@@ -1135,7 +1135,7 @@ VARIABLES = {
         ``example/components/xpcomsample.lib`` on Windows.
         """),
 
-    'SHARED_LIBRARY_NAME': (unicode, unicode,
+    'SHARED_LIBRARY_NAME': (str, str,
         """The name of the static library generated for a directory, if it needs to
         differ from the library code name.
 
@@ -1149,7 +1149,7 @@ VARIABLES = {
         Implies FORCE_SHARED_LIB.
         """),
 
-    'STATIC_LIBRARY_NAME': (unicode, unicode,
+    'STATIC_LIBRARY_NAME': (str, str,
         """The name of the static library generated for a directory, if it needs to
         differ from the library code name.
 
@@ -1185,37 +1185,37 @@ VARIABLES = {
 
         This variable contains a list of system libaries to link against.
         """),
-    'RCFILE': (unicode, unicode,
+    'RCFILE': (str, str,
         """The program .rc file.
 
         This variable can only be used on Windows.
         """),
 
-    'RESFILE': (unicode, unicode,
+    'RESFILE': (str, str,
         """The program .res file.
 
         This variable can only be used on Windows.
         """),
 
-    'RCINCLUDE': (unicode, unicode,
+    'RCINCLUDE': (str, str,
         """The resource script file to be included in the default .res file.
 
         This variable can only be used on Windows.
         """),
 
-    'DEFFILE': (unicode, unicode,
+    'DEFFILE': (str, str,
         """The program .def (module definition) file.
 
         This variable can only be used on Windows.
         """),
 
-    'LD_VERSION_SCRIPT': (unicode, unicode,
+    'LD_VERSION_SCRIPT': (str, str,
         """The linker version script for shared libraries.
 
         This variable can only be used on Linux.
         """),
 
-    'SYMBOLS_FILE': (Path, unicode,
+    'SYMBOLS_FILE': (Path, str,
         """A file containing a list of symbols to export from a shared library.
 
         The given file contains a list of symbols to be exported, and is
@@ -1270,7 +1270,7 @@ VARIABLES = {
         ``BIN_SUFFIX``, the name will remain unchanged.
         """),
 
-    'SONAME': (unicode, unicode,
+    'SONAME': (str, str,
         """The soname of the shared object currently being linked
 
         soname is the "logical name" of a shared object, often used to provide
@@ -1326,7 +1326,7 @@ VARIABLES = {
         ``GENERATED_FILES``.
         """),
 
-    'PROGRAM' : (unicode, unicode,
+    'PROGRAM' : (str, str,
         """Compiled executable name.
 
         If the configuration token ``BIN_SUFFIX`` is set, its value will be
@@ -1334,7 +1334,7 @@ VARIABLES = {
         ``BIN_SUFFIX``, ``PROGRAM`` will remain unchanged.
         """),
 
-    'HOST_PROGRAM' : (unicode, unicode,
+    'HOST_PROGRAM' : (str, str,
         """Compiled host executable name.
 
         If the configuration token ``HOST_BIN_SUFFIX`` is set, its value will be
@@ -1372,7 +1372,7 @@ VARIABLES = {
         files.
         """),
 
-    'XPIDL_MODULE': (unicode, unicode,
+    'XPIDL_MODULE': (str, str,
         """XPCOM Interface Definition Module Name.
 
         This is the name of the ``.xpt`` file that is created by linking
@@ -1441,7 +1441,7 @@ VARIABLES = {
          """),
 
     'WEBIDL_EXAMPLE_INTERFACES': (StrictOrderingOnAppendList, list,
-        """Names of example WebIDL interfaces to build as part of the build.
+        r"""Names of example WebIDL interfaces to build as part of the build.
 
         Names in this list correspond to WebIDL interface names defined in
         WebIDL files included in the build from one of the \*WEBIDL_FILES
@@ -1526,14 +1526,14 @@ VARIABLES = {
         """),
 
     # The following variables are used to control the target of installed files.
-    'XPI_NAME': (unicode, unicode,
+    'XPI_NAME': (str, str,
         """The name of an extension XPI to generate.
 
         When this variable is present, the results of this directory will end up
         being packaged into an extension instead of the main dist/bin results.
         """),
 
-    'DIST_SUBDIR': (unicode, unicode,
+    'DIST_SUBDIR': (str, str,
         """The name of an alternate directory to install files to.
 
         When this variable is present, the results of this directory will end up
@@ -1541,7 +1541,7 @@ VARIABLES = {
         otherwise be placed.
         """),
 
-    'FINAL_TARGET': (FinalTargetValue, unicode,
+    'FINAL_TARGET': (FinalTargetValue, str,
         """The name of the directory to install targets to.
 
         The directory is relative to the top of the object directory. The
@@ -1572,7 +1572,7 @@ VARIABLES = {
 
     'GYP_DIRS': (StrictOrderingOnAppendListWithFlagsFactory({
             'variables': dict,
-            'input': unicode,
+            'input': str,
             'sandbox_vars': dict,
             'no_chromium': bool,
             'no_unified': bool,
